<?php
  // clamav.php

  function analyseAVClamav ($serveur, $port, $fichier)
  {
    // Se connecte au serveur/port passe en argument et envoie le fichier pour 
    // analyse
    // renvoie OK si le fichier est sain
    // renvoie le nom du virus si il y a un virus
    // renvoie <0 si il y a un probleme

    // echo analyseAV("localhost", 3310, "/home/fournier/eicar.com")."\n";
    // Renvoie Eicar-Test-Signature FOUND
    // echo analyseAV("localhost", 3310, "/home/fournier/test.txt")."\n";
    // Renvoie OK

    // clamav fonctionne sur deux ports : 
    // - Le premier permet de se connecter au serveur et de demander un port 
    // pour l'analyse
    // - Une fois fourni, on se connecte au deuxieme port pour envoyer le 
    // fichier a scanner
    // Le resultat apparait sur le port principal

    if (!file_exists($fichier) || !is_readable($fichier))
      return -1;

    // Connexion au port principal de Clamav
    $sock = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
    socket_set_nonblock ($sock);
    @socket_connect ($sock, $serveur, $port);
    socket_set_block ($sock);
    $rc=socket_select ($r = array ($sock), $w = array ($sock), 
                       $f = array ($sock), 5);
    if ($rc==0)
      // Timeout pour l'essai de connexion au serveur Clamav
      // Tester le Timeout avec un filtre iptables
      // $IPTABLES -A OUTPUT -o lo -p tcp --sport 3310 -j DROP && \
      return -2;
    elseif ($rc==2)
      // Connection refusée au serveur Clamav
      return -3;
    // Connection etablie : envoi de l'ordre stream pour avoir un port de 
    //donnees
    socket_write ($sock, "STREAM");
    // Recuperation de ce port de donnees
    $line = socket_read ($sock, 20);
    // $line is PORT 1535
    // Check for PORT and catch port number
    if (substr ($line,0,4) !== "PORT")
      // After STREAM, server doesn't answer PORT
      return -4;
    $analysePort=substr (trim ($line), 5);

    // Commence la connexion de donnees
    $sockData = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
    socket_connect ($sockData, $serveur, $analysePort);
    $rc = socket_select ($r = array($sockData), $w = array($sockData),
                         $f = array($sockData), 5);
    if ($rc === 0)
      // Timeout to Clamav Data port
      return -5;
    elseif ($rc === 2)
      // Connection refused to Data port
      return -6;

    // OK : Envoi des donnees pour analyse
    socket_write ($sockData, file_get_contents ($fichier));
    // Fermeture de la socket pour signaler la fin du fichier au serveur
    socket_close( $sockData);

    // Recupere le virus eventuel ou le statut OK depuis le canal principal
    $line = socket_read ($sock, 255);
    // On nettoie un peu : suppression de "stream:" et du retour chariot final
    $line = substr($line,8,-1);

    // Close
    socket_close ($sock);

    // Retourne le virus
    return "$line";
  }

?>
