<?
  /**
  *    Check Eval
  *    Performs a Syntax check without killing the parser (hopefully)
  *    Verifie la syntaxe d'un code PHP, sans l'executer
  *    http://fr2.php.net/php_check_syntax
  *
  *    @params        string        PHP to be evaluated
  *    @return        array        Parse error info or true for success
  Renvoie :
  array(2) {
    ["line"]=>
    int(3)
    ["msg"]=>
    string(65) " unexpected '"', expecting T_STRING or T_VARIABLE or T_NUM_STRING"
  }

  TRUE si tout va bien.
  **/
  function checkEval ($php)
  {
    $evalStr = 'return;';

    // Get the string tokens
    $crack = token_get_all ($php);

    // Parser tokens to check for we are only checking the first token because
    // anything else would result in an expected syntax error
    $tokens = array (T_OPEN_TAG, T_OPEN_TAG_WITH_ECHO);

    // Check to see how we need to proceed prepare the string for parsing
    if (isset ($crack[0]) && in_array ($crack[0][0], $tokens, true))
        $evalStr .= '?>';

    // Make sure syntax reporting is on...probably only need E_PARSE... but I'm
    // anal
    $oldErr = error_reporting (E_ALL | E_STRICT);

    // Prevent output
    ob_start();
    $test = eval ($evalStr.$php);
    $evaluput = ob_get_clean();

    // Reset error reporting
    error_reporting ($oldErr);

    // Only do this if there was output
    if ($evaluput !== '')
    {
        // Strip annoying html tags, in case html reporting is enabled in
        // php.ini
        $evaluput = strip_tags ($evaluput);
        // Fancy Regex to pull the error that killed us
        $pattern    = '/Parse error:\s*syntax error,(.+?)\s+in\s+.+?\s*'.
                      'line\s+(\d+)/';
        $parse_fail    = (bool)preg_match ($pattern, $evaluput, $match);

        // Parse error to report ?
        if ($parse_fail === true)
        {
            return array (
                'line'    =>    (int)$match[2],
                'msg'    =>    $match[1]
            );
        }
    }
    return true;
  }

  // Verification lors du demarrage du cluster (les verification sont aussi
  // faites lors des rechargement des configurations par les kill -HUP
  if (($ret = checkEval(file_get_contents("config.php"))) !== TRUE)
  {
    echo $ret["msg"]." (ligne ".$ret["line"]." dans ".getcwd()."/config.php)\n";
    //criclog ($ret["msg"]." (ligne ".$ret["line"]." dans ".getcwd()."/config.php)");
    exit (1);
  }
  /////////////////////
  // TESTS UNITAIRES //
  /////////////////////
  //var_dump(checkEval(file_get_contents("config.php")));

?>
