<?
  // logger.php

  error_reporting(E_ALL | E_STRICT);

  // Gere tous les logs du programme

  ////////////////////////
  // TESTS DE DEMARRAGE //
  ////////////////////////
  if (!isset ($conf["loggerFile"]))
    die ("\$conf[\"loggerFile\"] n'est pas disponible pour logger\n");
  if (!is_file($conf["loggerFile"]))
  {
    if (!is_writeable(dirname($conf["loggerFile"])))
      die ("Le fichier ".$conf["loggerFile"]." n'existe pas, et le prog n'a ".
           "pas les droits pour le créer\n");
  }
  else  if (!is_writeable($conf["loggerFile"]))
    // Le fichier existe, on regarde si on peut ecrire
    die ("Le fichier de log ".$conf['loggerFile']." n'est pas inscriptible\n");
  else
    // Le fichier n'existe pas : on le cree
    touch ($conf['loggerFile']);
  if (!isset ($conf["timezone"]))
    die ("\$conf[\"timezone\"] n'est pas defini dans logger\n");

  ////////////////////
  // INITIALISATION //
  ////////////////////
  // Liste des timezone sur : http://fr.php.net/manual/en/timezones.php
  date_default_timezone_set($conf["timezone"]);
  ini_set ("date.timezone", $conf["timezone"]);

  ///////////////
  // FONCTIONS //
  ///////////////
  function debug($msg, $niveau)
  {
    // Gestionnaire de trigger_error
    // Le niveau est E_USER_WANING, E_USER_NOTICE

    global $conf;
    if (gettype($msg)=="array")
    {
      foreach ($msg as $key=>$ligne)
      {
        trigger_error ("$key=>$ligne", $niveau);
      }
    }
    else
    {
      trigger_error ("$msg", $niveau);
    }
  }

  function criclog($msg)
  {
    // Gestionnaire de messages d'erreur (si on est en mode trigger_error, on
    // foure d'office l'erreur dans le trigger_error
    global $conf;
    $fp=fopen ($conf["loggerFile"],"a");
    if ($fp===FALSE)
      die ("Le fichier de log ".$conf["loggerFile"]." n'est pas "
          ."inscriptible\n");
    $date=date("d/m/Y H:i:s");
    $progname=substr(basename($_SERVER['SCRIPT_FILENAME']),0,-4);
    if (gettype($msg)=="array")
    {
      foreach ($msg as $key=>$ligne)
      {
        fwrite ($fp, $date." [".sprintf("%18s",$progname). "] ".
                     $key."=>".$ligne."\n");
      }
    }
    else
    {
      fwrite ($fp, $date." [".sprintf("%18s",$progname). "] ".$msg."\n");
    }
    fflush($fp);
    fclose ($fp);
  }

  ///////////
  // TESTS //
  ///////////
/*
error_reporting(511);
  trigger_error ("Coucou", E_USER_NOTICE);
  trigger_error ("SSH", E_USER_WARNING);
error_reporting(1023);
  trigger_error ("Coucou2", E_USER_NOTICE);
  trigger_error ("SSH2", E_USER_WARNING);
error_reporting(2047);
  trigger_error ("Coucou3", E_USER_NOTICE);
  trigger_error ("SSH3", E_USER_WARNING);
  //criclog ("COUCOU");
*/
?>
