<?php
  ////////////////////////////
  //   LANGUAGE SELECTION   //
  ////////////////////////////
  function languageSelected ()
  {
    // Return the user's selected language. If there is not, use the browser
    // and in last case, the $defaultLanguage.
    // $languagesEnabled must be an array of the enabled languages
    global $conf;
    $lang = $conf['defaultLanguage'];

    if (isset ($_COOKIE['language']) &&
        in_array ($_COOKIE['language'], $conf['languagesEnabled']))
    {
      $lang = $_COOKIE['language'];
    }
    elseif (isset ($_SERVER['HTTP_ACCEPT_LANGUAGE']))
    {
      $_SERVER['HTTP_ACCEPT_LANGUAGE'] = strtolower (
                                            $_SERVER['HTTP_ACCEPT_LANGUAGE']);
      $list = explode (',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
      foreach ($list as $langtmp)
      {
        list ($lang2, ) = explode (';', $langtmp);
        if (in_array ($lang2, $conf['languagesEnabled']))
        {
          $lang = $lang2;
          break;
        }
      }
    }
    return $lang;
  }

  function t ($text)
  {
    $lang = languageSelected ();
    require ("lang/$lang.php");
    if (isset ($texts["$text"]))
    {
      $text = $texts["$text"];
    }
    else
    {
      trigger_error ("Lang '$lang' : Not translated string '$text'");
    }

    $arr  = func_get_args();
    switch (func_num_args ())
    {
      case 1 : $str = $text; break;
      case 2 : $str = sprintf ($text, $arr[1]); break;
      case 3 : $str = sprintf ($text, $arr[1], $arr[2]); break;
      case 4 : $str = sprintf ($text, $arr[1], $arr[2], $arr[3]); break;
      default:
        trigger_error ("Function t() : too much parameters (".func_num_args ().
                       ")", E_USER_ERROR);
    }
    return htmlspecialchars ($str, ENT_QUOTES);
  }

?>
