<?php
  // objets.php

  function checkbox($name, $value, $label="", $select=array(), $javascript="")
  {
    // Cette fonction dessine une checkbox. Elle portera le nom 'name', aura un 
    // label '$label' et sera cochee si elle appartient au tableau $select.
    // Si on ne met pas de label, il vaut $value.
    $id = str_replace(array ("[", "]"), "-", $name);
    echo "<input type='checkbox' name='$name' id='$id' value='$value' ";
    if (!empty($select))
    {
      if (is_array ($select) && in_array($value, $select))
        echo "checked='checked' ";
      if (is_string ($select) && $select!="")
        echo "checked='checked' ";
    }
    echo "$javascript/>";
    // On veut pouvoir cliquer sur le texte en plus de la case a cocher.
    // Si la case est desactivee (en readonly), on ne permet pas le changement
    // en cliquant sur le texte
    echo "<span onclick='if (document.getElementById(\"$id\").disabled==false)";
    echo "{document.getElementById(\"$id\").checked=";
    echo "(!document.getElementById(\"$id\").checked)}'>";
    if ($label=="")
    {
      $label=$value;
    }
    echo htmlentities("$label", ENT_QUOTES, "UTF-8")."</span>\n";
  }

  function listeCheckBox ($name, $size, $values, $labels=array(),
                          $select=array(), $javascript="")
  {
    // Affiche une liste de checkboxes (comme une selectList mais avec des 
    // checkboxes). Chaque checkbox peut etre selectionnee independament des 
    // autres
    $size = $size *22; // On fait croire que la ligne de base fait 22px de haut 
    echo "<!-- listeCheckBox -->\n";
    echo "<div style='overflow:auto;height:${size}px;'>\n";
    foreach ($values as $value)
    {
      if (isset ($labels[$value])) 
        $label=$labels[$value];
      else
        $label = "";
      checkbox("${name}[${value}]", $value, $label, $select, $javascript);
      echo "<br/>\n";
    }
    echo "</div>\n";
    echo "<!-- listeCheckBox Fin -->\n";
  }

  function selectList ($name, $multiple, $size, $values, $label=array(),
                       $select=array(), $javascript="")
  {
    // Affiche une comboList ou une liste a plusieurs entrees
    // $name est le nom de la liste deroulante qui sera renvoyee dans la
    // variable GET/POST. Definit aussi id.
    // $multiple prend si la selection de plusieurs lignes est possible (non
    // utilise si $size=1). Attend un boolean
    // $size indique le nombre de lignes affichees
    // $values : tableau contenant en valeur la liste des valeurs. Si $label 
    // n'est pas fourni, cette valeur est affichee
    // $label : tableau contenant "$value"=>"$label". Si la valeur n'est pas 
    // definie, on utilise le $value comme label.
    // $select : liste des cases selectionnees, s'appuyant sur $value. Si on
    // fournit un texte a la place d'un tableau, on ne selectionne qu'une case
    // $javascript s'applique a chaque element de la liste d'option
    
    // $name peut contenir des crochets (pour un traitement par tableau). ID ne
    // peut pas en contenir : on les remplace par un tiret
    $id = str_replace(array ("[", "]"), "-", $name);
    echo "<!-- selectList -->\n";
    echo "<select name='$name' id='$id'";
    if ($multiple !== FALSE) echo " multiple='multiple'";
    echo " size='$size'>\n";
    foreach ($values as $value)
    {
      echo "  <option value='$value'";
      if ((is_string ($select) && $select===$value) ||
          (is_array ($select) && in_array ($value, $select)))
        echo " selected='selected'";
      if ($javascript !== "") echo " $javascript";
      echo ">";
      if (isset ($label[$value]))
        echo htmlentities($label[$value], ENT_QUOTES, "UTF-8");
      else
        echo htmlentities($value, ENT_QUOTES, "UTF-8");
      echo "</option>\n";
    }
    echo "</select>\n";
    echo "<!-- selectList Fin -->\n";
  }

?>
