<?php
  // LDAP/chercher.php

  error_reporting (E_ALL);
  function chercher ($base, $filter, $justThese, $ldapServer, $ldapPort, 
                     $ldapBindDN = NULL, $ldapBindPassword = NULL)
  {
    // Cette fonction interroge l'annuaire LDAP central avec les informations
    // fournies
    // Return Values : 
    //  - Un tableau avec les entrees trouvees (donc eventuellement vide)
    //  - Une chaine avec l'erreur si le LDAP est indisponible

    if (! function_exists ('ldap_connect'))
      return 'Support LDAP Indisponible sur le PHP de ce serveur';

    // Connexion à l'annuaire
    $ldapconn = ldap_connect ($ldapServer, $ldapPort);
    if ($ldapconn === FALSE)
      return 'LDAP not found';

    // Configuration de la socket
    ldap_set_option ($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);

    // Attachement avec le compte d'authentification fourni
    $ldapbind = @ldap_bind ($ldapconn, $ldapBindDN, $ldapBindPassword);
    if (ldap_errno ($ldapconn) != 0 || $ldapbind === FALSE)
      return 'LDAP Bind Error / LDAP server not available';

    $sr = ldap_search ($ldapconn, $base, $filter, $justThese);
    if ($sr === FALSE)
    {
      trigger_error ("LDAP : Request error : '$base' '$filter' ".
                     implode ("'", $justThese)." : " .ldap_error ($ldapconn),
                     E_USER_ERROR);
      ldap_close ($ldapconn);
      return 'LDAP : Request error';
    }
    $info = ldap_get_entries ($ldapconn, $sr);
    ldap_close ($ldapconn);
    return $info; 
  }

?>
