<?
  // module.php

  // Gestion des modules du kernel

  error_reporting(E_ALL | E_STRICT);

  ////////////////////////////////
  // VERIFICATIONS DE DEMARRAGE //
  ////////////////////////////////
  if (!file_exists("/sbin/modprobe"))
    die ("ERREUR : /sbin/modprobe inexistant\n");
  if (!file_exists("/sbin/rmmod"))
    die ("ERREUR : /sbin/rmmod inexistant\n");

  ///////////////
  // FONCTIONS //
  ///////////////
  function module_charge ($moduleCherche)
  {
    // Verifie si le module $module est correctement charge
    // Renvoie FALSE si le fichier /proc/modules est illisible
    // Renvoie 1 si le module est bien charge
    // Renvoie 0 si le module n'est pas charge

    if (($fileMod=file("/proc/modules"))===FALSE)
      return FALSE;
    foreach ($fileMod as $ligne)
    {
      list ($module, $reste)=explode (" ", $ligne);
      if ($moduleCherche==$module)
      {
        // Trouve le module cherche
        return 1;
      }
    }
    return 0;
  }

  function kernelVersion()
  {
    // Cette fonction renvoie la version de kernel courante (utilisable pour
    // les modules par exemple
    $tab = explode (" ",file_get_contents ("/proc/version"));
    return $tab[2];
  }

  ///////////
  // TESTS //
  ///////////
/*  echo module_charge("processor")."\n";
  echo module_charge("processor2")."\n";
  echo module_charge("proc")."\n";
  echo module_charge("ext3")."\n";
  echo kernelVersion()."\n";
*/
?>
