<?php
  function csv2table ($fichierCSV, $separateur, $encadrement="")
  {
    // Cette fonction lit le fichier CSV, en fonction du separateur $separateur
    // et retourne le tableau des donnees en associatif.
    // Retourne FALSE en cas d'erreur
    // La premiere ligne du fichier CSV doit contenir le nom des champs.
    // Si les champs sont encadres par des apostrophes ou des guillemets dans le
    // fichier CSV, placer dans $encadrement le caractere d'encadrement
    // Les champs vides sont retournes comme ""
    $ret = array();
    if (!is_file ($fichierCSV) || !is_readable ($fichierCSV))
      return FALSE;

    $allDatas = array();
    if (($handle = fopen($fichierCSV, "r")) !== FALSE)
    {
      // Lecture des champs (1e ligne)
      $champs = fgetcsv($handle, 1000, $separateur, $encadrement);
      if ($champs === FALSE)
      {
        // Fichier vide
        return (array());
      }

      // Lecture du reste
      while (($data = fgetcsv($handle, 1000, $separateur, $encadrement))
             !== FALSE)
      {
        $allDatas[] = $data;
      }
      fclose($handle);
    }

    foreach ($allDatas as $ligne=>$datas)
    {
      foreach ($datas as $key=>$data)
      {
        $ret[$ligne][$champs[$key]]=$data;
      }
    }
    return $ret;
  }

?>
