<?php
  // html.php

  function htmlToTexte ($messageHTML, $charset ='utf-8', $presentation=FALSE)
  {
    // Cette fonction convertit le texte HTML fourni, de type $charset,
    // en texte pur
    // Ajoute les caracteres /,*,_ pour les italiques, les gras et les soulignes
    // si $presentation est a TRUE
    // Un probleme signale : strip_tags ne fonctionne pas dans toutes les situations.
    // On le remplace par la fonction issue des aides du site PHP
    $patterns = array();
    $remplacements = array ();
    if ($presentation === TRUE)
    {
      $patterns[0] = '@<i>@i';
      $patterns[1] = '@</i>@i';
      $patterns[2] = '@<b>@i';
      $patterns[3] = '@</b>@i';
      $patterns[4] = '@<u>@i';
      $patterns[5] = '@</u>@i';
      $remplacements[0] = '/';
      $remplacements[1] = '/';
      $remplacements[2] = '*';
      $remplacements[3] = '*';
      $remplacements[4] = '_';
      $remplacements[5] = '_';
    }
    // On remplace tout d'abord en fonction du codage de caracteres les 
    // codes &#xx.
    // Si necessaires on fait les remplacements <i> en /, <b> en *, et <u> en _
    // Ensuite, on change tous les <br> en retours chariots
    // Une fois fait, on supprime toutes les balises HTML.
    // Comme la gestion des retours-chariots est mal faite, on trim pour 
    // supprimer les lignes blanches en tete.
    return html2txt (preg_replace ($patterns, $remplacements,
                      html_entity_decode ($messageHTML, ENT_QUOTES, $charset)
                    ));

    return trim (strip_tags (
                  br2nl (
                    preg_replace ($patterns, $remplacements, 
                      html_entity_decode ($messageHTML, ENT_QUOTES, $charset)
                    )
                  )
                ));
  }

  function br2nl ($string)
  {
    // Convertit tous les <br> en retours chariots.
    // Issu de http://fr.php.net/manual/en/function.nl2br.php#94884
    return preg_replace ('@<br[[:space:]]*/?[[:space:]]*>@i',
                             chr(13).chr(10),
                             $string);
  }

  function html2txt ($document)
  {
    $search = array('@<script[^>]*?>.*?</script>@si',  // Strip out javascript
                    '@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags
                    '@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
                    '@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments including CDATA
    );
    $text = preg_replace($search, '', $document);
    return $text;
  }

  function htmlent ($texte)
  {
    // Cette fonction renvoie le texte passe en parametre en HTML grace a 
    // htmlentities, en UTF-8 avec les quotes corrigees.
    return htmlentities ($texte, ENT_QUOTES, "UTF-8");
  }

?>
