<?php
  // maildir.php

  // Fonction permettant la gestion des stockages Maildir

  function folderMaildirEncoding ($folder)
  {
    // Cette fonction encode le nom de folder $folder selon le format necessaire
    // aux repertoires Maildir.
    // Le format est decrit dans maildir(5) : http://linux.die.net/man/5/maildir
    // $folder doit etre au format UTF-8
    // Renvoie le nom du repertoire corrige ou FALSE si il y a un slash ou un
    // point dans le nom du folder
    // Ex. : "Résumé" renvoie "R&AOk-sum&AOK-"

    $long = mb_strlen ($folder, "UTF-8");
    if (mb_strpos ($folder, "/") !== FALSE || 
        mb_strpos ($folder, ".") !== FALSE)
    {
      // le point ou le slash sont interdits : on les jette
      return FALSE;
    }
    $resultat = "";
    for ($i = 0 ; $i < $long ; $i++)
    {
      $car = mb_substr ($folder, $i, 1, "UTF-8");
      $carVal = ord($car);
      // On convertit tout sauf les codes ASCII.
      // Dons les codes Ascii, on convertit le &,
      // echo "$car=$carVal";
      if ($carVal < 20 || $carVal > 127 || $carVal == 38 || $carVal == 46 ||
          $carVal == 47)
      {
        // echo " -> Converti\n";
        $car2 = iconv("UTF-8","UTF-7", $car);
        $car2 = str_replace("+", "&", $car2);
        $resultat .= $car2;
      }
      else
      {
        // echo " -> Normal\n";
        $resultat .= $car;
      }
    }
    return $resultat;
  }

