<?php
  // verifParam.php

  // Cette bibliotheque permet de verifier si les chaines issues de 
  // l'utilisateur sont correctes

 function loginOK ($l)
  {
    // Verifie si le login passe est correct dans sa syntaxe
    // Renvoie TRUE si login OK
    // Renvoie FALSE si incorrect
    $char = strspn($l,"abcdefghijklmnopqrstuvwxyz".
                      "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_.");
    if((strlen($l) >= 3) && (strlen($l) < 64) && (strlen($l) == $char))
    {
      return TRUE;
    }
    else
    {
      return FALSE;
    }
  }

  function telephoneOK ($telephone)
  {
    // Verifie si le telephone passe est bien correct dans sa syntaxe
    // renvoie TRUE si le telephone est OK
    // Renvoie FALSE si le telephone est incorrect
    $char = strspn($telephone, "0123456789");
    if (strlen($telephone) == 10 && strlen($telephone) == $char)
      return TRUE;
    return FALSE;
  }

  function codePostalOK ($code)
  {
    // Verifie si le code postal passe est bien correct dans sa syntaxe
    // renvoie TRUE si le code postal est OK
    // Renvoie FALSE si le code postal est incorrect
    $char = strspn($code, "0123456789");
    if (strlen($code) == 5 && strlen($code) == $char)
      return TRUE;
    return FALSE;
  }

  function emailOK ($email)
  {
    // Verifie si le email passe est bien correct dans sa syntaxe
    // renvoie TRUE si le email est OK
    // Renvoie FALSE si le email est incorrect
    $char = strspn($email, "abcdefghijklmnopqrstuvwxyz".
                           "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.@_-");
    if (strlen($email) <= 255 && strlen($email) > 4 && strlen($email) == $char
        && strpos ($email, "@") && substr_count ($email, "@") === 1
       )
      return TRUE;
    return FALSE;
  }

  function domaineOK ($domaine)
  {
    // Verifie si le domaine passe est bien correct dans sa syntaxe
    // renvoie TRUE si le domaine est OK
    // Renvoie FALSE si le domaine est incorrect
    // TODO : Support des noms de domaines internationalises (RFC 3490)
    $domaine = strtolower ($domaine);
    $char = strspn($domaine, "abcdefghijklmnopqrstuvwxyz0123456789.-");
    if (strlen($domaine) <= 63 && strlen($domaine) > 4 &&
        strlen($domaine) == $char
       )
      return TRUE;
    return FALSE;
  }

  function FQDNOK ($fqdn)
  {
    // Verifie si le FQDN passe est bien correct dans sa syntaxe
    // renvoie TRUE si le FQDN est OK
    // Renvoie FALSE si le FQDN est incorrect
    // TODO : Support des noms de domaines internationalises (RFC 3490)
    $fqdn = strtolower ($fqdn);
    $char = strspn($fqdn, "abcdefghijklmnopqrstuvwxyz0123456789.-");
    if (strlen($fqdn) <= 253 && strlen($fqdn) > 4 &&
        strlen($fqdn) == $char
       )
      return TRUE;
    return FALSE;
  }
?>
