<?
   // $Id: presentation.php 24 2006-10-03 19:22:34Z fournier $

  /**
   * @author Dominique Fournier <dominique@fournier.homedns.org>
   * @param $titre Message a mettre dans le titre
   * @param $javascript (non obligatoire) Javascript a inserer dans l'entete
   * @return void
   *
   * Ecrit tout l'entete de page, avec le titre et le javascript eventuel passe
   * en argument
   */
  function entete ( $titre, $javascript="" )
  {
    // Affiche l'en-tete
    echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" ";
    echo "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
    echo "<html>\n";
    echo "  <head>\n";
    echo "    <meta http-equiv=\"Content-Type\" content=\"text/html; ";
    echo "charset=UTF-8\" />\n";
    echo "    <title>$titre</title>\n";
    if ( $javascript != "" )
    {
      echo "    <script type='Javascript'><!-\n";
      echo "$javascript\n";
      echo "    -></script>\n";
    }
    echo "    <link href='/favicon.ico' rel='shortcut icon' type='image/x-icon'  />\n";
    if ( file_exists ( 'style.css' ) )
      echo "    <link type='text/css' rel='stylesheet' media='screen,all' href='style.css' />\n";
    if ( file_exists ( 'style.php' ) )
      echo "    <link type='text/css' rel='stylesheet' media='screen,all' href='style.php' />\n";
    if ( file_exists ( 'print.php' ) )
      echo "    <link type='text/css' rel='stylesheet' media='print' href='print.php' />\n";
    echo "  </head>\n";
    echo "  \n";
    echo "  <body>\n";
  }

  /**
   * @author Dominique Fournier <dominique@fournier.homedns.org>
   * @param $comment (non obligatoire) Message a mettre dans le commentaire
   * @return void
   *
   * Ecrit le pied de page, avec un commentaire eventuel.
   * Une constante PROGRAMME doit donner le nom de programme.
   */
  function pieddepage ( $comment="" )
  {
    echo "    <table width='100%' class='status'><tr>";
    echo "<td align='left'>&nbsp;$comment&nbsp;</td>";
    echo "</tr></table>\n";
    echo "    <table width='100%'><tr><td align='center'>";
    if ( defined ( 'PROGRAMME' ) ) echo PROGRAMME." ";
    echo "&copy; ";
    if (defined ("DATESTART")) echo DATESTART."-";
    echo strftime ("%Y");
    echo " - D. Fournier</td></tr></table>\n";
    echo "  </body>\n";
    echo "</html>\n";
    exit;
  }

  /**
   * @author Dominique Fournier <dominique@fournier.homedns.org>
   * @param $message Message a afficher a l'ecran
   * @param $log Message a mettre dans le log
   * @param $debug Niveau de debug avant d'ecrire le probleme
   * @return void
   *
   * Ecrit le message passé à l'écran et met $log dans le log si
   * la fonction de debug existe.
   * Une constante PROGRAMME doit donner le nom de programme.
   */
  function pagederreurfatale ( $message, $log="", $debug )
  {
    entete ("ERREUR FATALE");
    echo "<br/>\n";
    echo "<center>\n";
    echo "<h4>$message</h4>\n";
    echo "<br />\n";
    echo "Contactez l'administrateur de site<br/>\n";
    echo "</center>\n";
    if ( function_exists ("debug") ) 
    {
      if ( $log == "" ) $log = $message;
      debug ( $debug."\n", $log );
    }
    pieddepage ();
  }
?>
