<?
  // alerteCluster.php

  // Ce programme recoit les alertes depuis le cluster, diffuse l'audio et place
  // un log.

  ///////////////////
  // CONFIGURATION //
  ///////////////////

  // Fichier de log
  $conf["log"]="/var/log/traceI";

  // Repertoire ou sont ranges les sons
  $conf["repson"]="/root/cluster/surveillance/sons";

  // Repertoire de gestion de l'ordre de lecture
  $conf["repordre"]="/var/lib/alerteCluster/ordre";

  // Repertoire de limitation du nombre d'alertes
  // Tout fichier place dans ce repertoire bloque la lecture si le developpeur
  // a demande un temps minimum entre deux lectures
  $conf["reptemps"]="/var/lib/alerteCluster/reptemps";

  // Fichier contenant les derniers sons joues pour pouvoir faire un Repeat
  $conf["replay"]="/var/cache/gestion_alertes/dernier";

  // On n'affiche pas les erreurs en HTML (elles sont recuperees par le cluster
  // et envoyees par mail);
  ini_set ("html_errors", 0);

  /////////////////////////
  // PROGRAMME PRINCIPAL //
  /////////////////////////
 
  function debug($msg)
  {
    // Gestionnaire de debug
    // On va mettre un niveau gere par bits

    // Si pas de debug : mettre le return
    return;

    $conf["loggerFile"]="/var/log/alerteCluster.php";
    $fp=fopen ($conf["loggerFile"],"a");
    if ($fp===FALSE)
      die ("Le fichier de log ".$conf["loggerFile"]." n'est pas "
          ."inscriptible\n");
    $date=date("d/m/Y H:i:s");
    $progname=substr(basename($argv[0]),0,-4);
    $debutligne="$date DEBUG ";
    if (is_array($msg))
    {
      foreach ($msg as $key=>$ligne)
      {
        fwrite ($fp, "$debutligne $key=>$ligne\n");
      }
    }
    else
    {
      fwrite ($fp, "$debutligne $msg\n");
    }
    fflush($fp);
    fclose ($fp);
  }

  ///////////////////
  // VERIFICATIONS //
  ///////////////////
  // Verifications du repertoire d'ordonnancement
  if (!file_exists($conf["repordre"]))
    die ("Créer le répertoire ".$conf["repordre"]."\n");
  if (!is_dir($conf["repordre"]))
    die ($conf["repordre"]." n'est pas un répertoire\n");
  if (!is_writeable($conf["repordre"]))
    die ("Répertoire ".$conf["repordre"]." protégé en écriture\n");

  // Verifications du repertoire de limitations d'alertes
  if (!file_exists($conf["reptemps"]))
    die ("Créer le repertoire ".$conf["reptemps"]."\n");
  if (!is_dir($conf["reptemps"]))
    die ($conf["reptemps"]." n'est pas un répertoire\n");
  if (!is_writeable($conf["reptemps"]))
    die ("Répertoire ".$conf["reptemps"]." protégé en écriture\n");

  // Verifications du fichier de logs
  if (file_exists ($conf["log"]) && !is_writeable ($conf["log"]))
    die ("Le fichier de log ".$conf["log"]." n'est pas inscriptible\n");
  elseif (!file_exists ($conf["log"]) && !is_writeable (dirname ($conf["log"])))
    die ("Le répertoire ".dirname ($conf["log"])." n'est pas inscriptible et ".
         "le fichier de log ".$conf["log"]." n'existe pas\n");

  // Verification du fichier de replay
  if (file_exists ($conf["replay"]) && !is_writeable ($conf["replay"]))
    die ("Le fichier de replay ".$conf["replay"]." n'est pas inscriptible\n");
  elseif (!file_exists ($conf["replay"]) && 
          !is_writeable (dirname ($conf["replay"])))
    die ("Le répertoire ".dirname ($conf["replay"])." n'est pas inscriptible ".
         "et le fichier de replay ".$conf["replay"]." n'existe pas\n");

  // Verifications de la lecture du son
  // Recherche du logiciel lecteur de son dans le PATH
  $pathes=explode (":", getenv("PATH"));
  if ($pathes===FALSE)
    die ("Pas de PATH disponible");
  foreach ($pathes as $path)
  {
    if (file_exists("$path/aplay") && is_executable("$path/aplay"))
    {
      $lecteur="$path/aplay";
      break;
    }
    if (file_exists("$path/play") && is_executable("$path/play"))
    {
      $lecteur="$path/play";
      break;
    }
  }
  if (!isset($lecteur))
    die ("Pas de lecteur de son disponible : installer aplay ou play\n");


  // Verification si le droit de lire le fichier existe
  if (basename($lecteur)==="play")
  {
    // SOX
    if (!file_exists("/dev/dsp"))
      die ("/dev/dsp n'existe pas\n");
    if (!is_writeable("/dev/dsp"))
      die ("/dev/dsp n'est pas incriptible\n");
  }
  else
  {
    // ALSA
    $listeAlsa=glob("/dev/snd/pcm*");
    foreach ($listeAlsa as $devAlsa)
    {
      if (!is_writeable($devAlsa))
        die ("$devAlsa  n'est pas incriptible\n");
    }
  }

  if ($_POST["message"])
    debug ($_POST["message"]);

  /////////////////////
  // GESTION DU TEST //
  /////////////////////
  if (isset ($_POST["message"]) && $_POST["message"]==="test")
  {
    // Ceci est le test regulier de la connexion. Doit afficher OK sinon un 
    // mail sera envoye a l'administrateur par le cluster avec le message 
    // d'erreur.
    $son="sonVide.wav";
    exec ("$lecteur -q $son", $output, $rc);
    echo "OK\n";
    exit;
  }
  
  ///////////////
  // DEMARRAGE //
  ///////////////
  // Si une machine envoie le message "demarrage", on efface toutes les alertes
  // qui sont dans la file pour qu'elles puissent etre rejouees.
  if (isset ($_POST["message"]) && 
      substr($_POST["message"], 0, 16)=="demarrageMachine")
  {
    $serveur=substr ($_POST["message"], 17);
    $listeFich=glob($conf["reptemps"]."/".urlencode("[$serveur]")."*");
    foreach ($listeFich as $file)
    {
      unlink($file);
    }
    echo "OK\n";
    exit;
  }

  ////////////////////////////////
  // GESTION DU TOUR DE LECTURE //
  ////////////////////////////////
  // Si on a plusieurs alertes audio en meme temps, c'est tres desagreable. 
  // Chaque message est donc muni d'un numero d'ordre. Le plus petit est lu le
  // premier et le plus grand attend que le petit aie termine. Ceci sera valable
  // tant que microtime renverra un code correct (voir le probleme en 2039)
  list($usec, $sec) = explode(" ", microtime());
  $identifiant="$sec".substr($usec,1);
  clearstatcache();
  if (file_exists ($conf["repordre"]."/$identifiant"))
  {
    // Collision de message a la meme micro-seconde (n'arrive jamais, mais est
    // arrive le 02/02/2009 a 04:05)
    usleep (5);
    $identifiant="$sec".substr($usec,1);
  }
  // Je pose mon ordre dans le tour
  touch ($conf["repordre"]."/$identifiant");
  // Je regarde si c'est mon tour de parler (le fichier le plus petit de la 
  // liste correspond a mon identifiant)
  $listeFich=glob($conf["repordre"]."/*");
  while (basename($listeFich[0])!=$identifiant && 
         time()<intval($identifiant)+10)
  {
    // attend 100ms avant de reverifier
    usleep(100000);
    $listeFich=glob($conf["repordre"]."/*");
  }
  // OK, ici, j'ai attendu 10s ou c'est a moi de lire

  // Enregistrement du message
  if (isset ($_POST["message"]))
  {
    $message=stripslashes($_POST["message"]);
  }
  else
  {
    unlink ($conf["repordre"]."/$identifiant");
    die ("Message non passé\n"); 
  }

  $erreur="";

  ////////////////////////////////////////////////////
  // GESTION DE LA LIMITATION DU NOMBRE DE MESSAGES //
  ////////////////////////////////////////////////////
  if (isset($_POST["maxrepetition"]))
  {
    $maxrepetition=intval($_POST["maxrepetition"]);
    if ($maxrepetition<0)
    {
      $erreur.="Demande de maxrepetition<0 ($maxrepetition)\n";
    }
    elseif ($maxrepetition>0)
    {
      // OK on a une $maxrepetition valide, on verifie quand le message
      // a ete lu la derniere fois
      // $maxrepetition est en minutes !!
      $nomfich=$conf["reptemps"]."/".urlencode($message);
      if (file_exists($nomfich) && 
          filemtime($nomfich)+$maxrepetition*60>time())
      {
        //echo "Message deja lu : on saute\n";
        unlink ($conf["repordre"]."/$identifiant");
        echo "OK\n";
        exit;
      }
      // OK message a lire, on met le fichier
      touch ($nomfich);
    }
    else
    {
      // $maxrepetition==0 : on ne fait rien...
    }
  }

  ///////////////////////////
  // ENREGISTREMENT DU LOG //
  ///////////////////////////
  if (($fp=fopen ($conf["log"], "a"))===FALSE)
  {
    $erreur.="Fichier ".$conf["log"]." non inscriptible\n";
  }
  else
  {
    fwrite ($fp, date("d/m/Y H:i:s")." ");
    fwrite ($fp, "$message\n");
    fclose ($fp);
  }
  
  ////////////////////////////////
  // LECTURE DES SONS EVENTUELS //
  ////////////////////////////////
  if (isset ($_POST["audio"]))
    $sons=explode (" ", $_POST["audio"]);
  else 
    $sons=array ();

  $repete="";
  foreach ($sons as $son)
  {
    if (!isset($son))
    {
      $erreur.="Pas de fichier son fourni\n";
      continue;
    }
    $son=$conf["repson"]."/".urlencode($son);
    if (!file_exists($son))
    {
      $erreur.="Le fichier '$son' n'existe pas\n";
      continue;
    }
    if (!is_file($son))
    {
      $erreur.="Le fichier '$son' n'est pas un fichier\n";
      continue;
    }
    if (!is_readable($son))
    {
      $erreur.="Le fichier '$son' n'est pas lisible\n";
      continue;
    }
    $repete.="$son ";
    // Lecture du son 
    exec ("$lecteur -q $son", $output, $rc);
  }
  if ($repete!="")
  {
    // On sauvegarde pour pouvoir relire les sons avec R
    file_put_contents($conf["replay"], $repete);
  }
  unlink ($conf["repordre"]."/$identifiant");
  if ($rc!=0)
  {
    echo "Erreur lors de l'éxécution de '$lecteur -q $son' :";
    echo "-- $rc --\n";
    print_r ($output);
    if ($erreur!="")
      echo "$erreur";
  }
  else
  {
    //////////////////////////////
    // FIN NORMALE DU PROGRAMME //
    //////////////////////////////
    if ($erreur!="")
      echo "$erreur";
    else
    echo "OK\n";
  }
?>
